unit PasErrors;

interface

uses
  Windows, SysUtils;

type
  ErrMSG = (MSG_000,

    MSG_001,MSG_002,MSG_003,MSG_004,MSG_005,MSG_006,MSG_007,

    MSG_010,MSG_011,MSG_012,MSG_013,MSG_014,MSG_015,MSG_016,
    MSG_017,MSG_018,MSG_019,MSG_020,MSG_021,MSG_022,MSG_023,
    MSG_024,MSG_025,MSG_026,MSG_027,MSG_028,MSG_029,MSG_030,
    MSG_031,MSG_032,MSG_033,MSG_034,MSG_035,MSG_036,MSG_100,

    MSG_101,MSG_102,MSG_200,MSG_201,MSG_202,MSG_203,MSG_204,
    MSG_205,MSG_206,MSG_207,MSG_208,MSG_209,MSG_210,MSG_211,
    MSG_212,MSG_213,MSG_214,MSG_215,MSG_216,MSG_217,MSG_218,
    MSG_219,MSG_220,MSG_221,MSG_400,MSG_401,MSG_402,MSG_403,
    MSG_404,MSG_405,MSG_406,MSG_407,MSG_408,MSG_409,MSG_410,
    MSG_411,MSG_412,MSG_413,MSG_414,MSG_415,MSG_416,MSG_417,
    MSG_418,MSG_419,MSG_420,MSG_421,MSG_422,MSG_423,MSG_424,
    MSG_425,MSG_426,MSG_427,MSG_428,MSG_429,MSG_430,MSG_431,
    MSG_432,MSG_433,MSG_434,MSG_435,MSG_436,MSG_437,MSG_438,
    MSG_439,MSG_440,MSG_441,MSG_442,MSG_443,MSG_444,MSG_445,
    MSG_446,MSG_447,MSG_448,MSG_449,MSG_450,MSG_451,MSG_452,
    MSG_453,MSG_454,MSG_455,MSG_456,MSG_457,MSG_458,MSG_459
  );

  WarnMSG = (WMSG_000,WMSG_001,WMSG_002,WMSG_003,WMSG_004);

  procedure MakeError(Const N:ErrMSG; const I: String = '');
  procedure MakeWarning(Const N: WarnMSG; I: String);
  procedure WriteConsole(S: String;H: Byte; N: integer);

var
  Finish	            : Boolean;

  NameMSG : array [ErrMSG] of string[7] = ('MSG_000',

    'MSG_001','MSG_002','MSG_003','MSG_004','MSG_005','MSG_006','MSG_007',

    'MSG_010','MSG_011','MSG_012','MSG_013','MSG_014','MSG_015','MSG_016',
    'MSG_017','MSG_018','MSG_019','MSG_020','MSG_021','MSG_022','MSG_023',
    'MSG_024','MSG_025','MSG_026','MSG_027','MSG_028','MSG_029','MSG_030',
    'MSG_031','MSG_032','MSG_033','MSG_034','MSG_035','MSG_036','MSG_100',

    'MSG_101','MSG_102','MSG_200','MSG_201','MSG_202','MSG_203','MSG_204',
    'MSG_205','MSG_206','MSG_207','MSG_208','MSG_209','MSG_210','MSG_211',
    'MSG_212','MSG_213','MSG_214','MSG_215','MSG_216','MSG_217','MSG_218',
    'MSG_219','MSG_220','MSG_221','MSG_400','MSG_401','MSG_402','MSG_403',
    'MSG_404','MSG_405','MSG_406','MSG_407','MSG_408','MSG_409','MSG_410',
    'MSG_411','MSG_412','MSG_413','MSG_414','MSG_415','MSG_416','MSG_417',
    'MSG_418','MSG_419','MSG_420','MSG_421','MSG_422','MSG_423','MSG_424',
    'MSG_425','MSG_426','MSG_427','MSG_428','MSG_429','MSG_430','MSG_431',
    'MSG_432','MSG_433','MSG_434','MSG_435','MSG_436','MSG_437','MSG_438',
    'MSG_439','MSG_440','MSG_441','MSG_442','MSG_443','MSG_444','MSG_445',
    'MSG_446','MSG_447','MSG_448','MSG_449','MSG_450','MSG_451','MSG_452',
    'MSG_453','MSG_454','MSG_455','MSG_456','MSG_457','MSG_458','MSG_459'
  );

implementation

uses
  PasScanner;

procedure MakeError(Const N:ErrMSG; const I: String = '');
var
  S,FName   : String;
begin

  case ord(N) of

    001 : S:= 'Out of memory';
    002 : S:= 'Too many errors';
    003 : S:= 'Cannot create record file';
    004 : S:= 'Cannot create class file';
    005 : S:= 'Cannot open source file';
    006 : S:= 'Serious error occured, stopping compilation';
    007 : S:= 'Cannot create binary symbol file';

    008 : S:= 'Internal error #010';
    009 : S:= 'Internal error #011';
    010 : S:= 'Internal error #012';
    011 : S:= 'Internal error #013';
    012 : S:= 'Internal error #014';
    013 : S:= 'Internal error #015';
    014 : S:= 'Internal error #016';
    015 : S:= 'Internal error #017';
    016 : S:= 'Internal error #018';
    017 : S:= 'Internal error #019';
    018 : S:= 'Internal error #020';
    019 : S:= 'Internal error #021';
    020 : S:= 'Internal error #022';
    021 : S:= 'Internal error #023';
    022 : S:= 'Internal error #024';
    023 : S:= 'Internal error #025';
    024 : S:= 'Internal error #026';
    025 : S:= 'illegal character in number';
    026 : S:= 'illegal character in string';
    027 : S:= 'number too large';
    028 : S:= '   ';
    029 : S:= ' '+I+' : "'+TokenStr+'"';
    030 : S:= '    ';
    031 : S:= '   ';
    032 : S:= '   ';
    033 : S:= '   "'+I+'"  ';
    034 : S:= '--';
    035 : S:= 'unknown character "'+I+'", ignored';

    036 : S:= 'newline in string constant';
    037 : S:= 'error in preprocessor statement';
    038 : S:= 'character "'+I+'" expected, "%s" found';
    039 : S:= 'unexpected text "%s" after program end';
    040 : S:= 'identifier (name) expected';
    041 : S:= 'keyword "'+I+'" expected, "%s" found';
    042 : S:= 'unexpected token "'+I+'"';
    043 : S:= 'operator "=" expected, "%s" found';
    044 : S:= 'constant expected';
    045 : S:= 'unexpected end of file found';
    046 : S:= 'error in parameter list on token "%s"';
    047 : S:= 'operator ":=" expected, "%s" found';
    048 : S:= '"packed" arrays not supported; ordinary array will be used';
    049 : S:= 'sets are not supported in this version';
    050 : S:= 'enumerated types are not supported in this version';
    051 : S:= 'operator ".." expected, "%s" found';
    052 : S:= 'keyword "end" expected, "%s" found';
    053 : S:= '"with" is not supported in this version';
    054 : S:= 'keyword "then" expected, "%s" found';
    055 : S:= 'constant of type integer or char expected';
    056 : S:= 'operator ":=" expected';
    057 : S:= '"break" statemnt found outside of do-while, repeat-until or for loop';
    058 : S:= 'compiler does ot support the "finalization" part of the unit';
    059 : S:= 'procedures and functions may not contain body inside unit interface part';
    060 : S:= 'identifier "%s" already defined';
    061 : S:= 'method was already declared as forward';
    062 : S:= 'a %s with the same name was declared as forward';
    063 : S:= 'parameter list is shorter than the list in previous forward declaration';
    064 : S:= 'parameter list differs on element %s from the list in previous forward declaration';
    065 : S:= 'return type is different than the return type declared in the previous forward declaration';
    066 : S:= 'unknown type "%s"';
    067 : S:= '%s type expected';
    068 : S:= 'integer, char or string type expected';
    069 : S:= 'constant of type %s expected, %s found';
    070 : S:= '"%s" is not a constant';
    071 : S:= 'integer or char type expected';
    072 : S:= '%s type expected, %s type found';
    073 : S:= 'wrong type in interval definition';
    074 : S:= '"%s" is not a constant';
    075 : S:= 'type name or integer/char constant expected, "%s" found';
    076 : S:= 'error in interval definition';
    077 : S:= 'operand is wrong type';
    078 : S:= 'name "%s" already exists in a record declaration';
    079 : S:= 'procedure/function takes 0 arguments, brackets must be left out';
    080 : S:= 'procedure/function takes more than 0 arguments, "(" expected';
    081 : S:= 'parameter list is too short';
    082 : S:= 'error on parameter %s';
    083 : S:= 'left and right operands to ":=" must have the same type';
    084 : S:= '"." operator can only be used on record types';
    085 : S:= 'the record does not contain element named "%s"';
    086 : S:= '"[" operator can only be used on array types';
    087 : S:= 'error in array dimensions (array has %s dimensions, %s are specified)';
    088 : S:= 'identifier "%s" is not procedure, function, variable or unit name';
    089 : S:= 'identifier "%s" is not constant, function or variable name';
    090 : S:= 'only interval types can be used for array indexes';
    091 : S:= 'nested functions or procedures are not supported';
    092 : S:= 'function "%s" cannot be called from here; procedure call or assignement expected';
    093 : S:= '"run" is reserved name and cannot be used as a function or procedure name';
    094 : S:= 'only string, character, integer or boolean can be appended to string';
    095 : S:= 'files are not supported in this version';
    096 : S:= 'variable parameters are not supported and will be ignored';
    097 : S:= 'invalid interval';
    098 : S:= 'interval too large';
    099 : S:= 'only integer type can be used as string index';
    100 : S:= 'variables of interval type are not supported';
    101 : S:= 'only forward declaration supplied; the implementation is missing';
    102 : S:= 'case statement is not supported in this version';
    103 : S:= 'a value cannot be asigned to array. This will be fixed in future versions of MIDletPascal';
    104 : S:= 'unknown identifier';
    105 : S:= 'name of the procedure/function has already been taken by another identifier';
    106 : S:= 'arrays in records ("%s") are not yet implemented';
    107 : S:= 'unknown record element "%s"';
    108 : S:= 'failed to load "%s" library/unit';
    109 : S:= 'error reading external library file';
    110 : S:= 'could not load library/unit "%s" because identifier of the same name already exists';
    111 : S:= 'serious internal error in library';
    112 : S:= 'library/unit contains a method with an incorrect argument type';
    113 : S:= 'library/unit does not contain function "%s"';
    114 : S:= 'unit name must contain at least 2 characters';
    115 : S:= 'library/unit does not contain type "%s"';
    116 : S:= 'iterator used in for-loop must not be defined inside a library/unit';
    117 : S:= 'identifier "%s" is not a procedure or variable name';
    118 : S:= 'identifier "%s" is not a function, variable or constant name';
    119 : S:= 'identifier "%s" found in more units; use syntax "unit_name"."identifier" to resolve ambiguity';

  end;
  WriteConsole(S,0,ord(N));

  if (TokE=_toEOLN) then begin
    TokenCol:=TokenPrev+1;
  end;

  IF ScanItem=NIL THEN BEGIN
    FName:=ModNAME;
  END ELSE
    FName:=ExtractFileName(ScanItem.SrcName);

  ModNAME:='';
  halt;
end;

procedure MakeWarning(Const N: WarnMSG; I: String);
var
  S: String;
begin
  case ord(N) of
    001 : S:= '   ';
    002 : S:= 'variable ('+I+') not used';
    003 : S:= '"packed" arrays not supported; ordinary array will be used';
    004 : S:= 'variable parameters are not supported and will be ignored';
  end;
  WriteConsole(S,3,ord(N));
end;

function  CharToOem(s: String; const flag: boolean=false): String;
var
  i,code: Integer;
  ret   : String;
begin
  ret:='';
  for i:=1 to length(s) do
   begin
     code:=ord(s[i]);
     if not flag then
      case code of
        192..239: code:=code-64;
        240..255: code:=code-16;
     end else
      case code of
        128..175: code:=code+64;
        224..239: code:=code+16;
      end;
     Ret:=Ret+chr(code);
   end;
  CharToOem:=Ret;
end;

procedure WriteConsole(S: String;H: Byte; N: integer);
var
  FName: String;
begin

  IF ScanItem=NIL THEN BEGIN
    FName:=ModNAME;//Name+Ext;
  END ELSE
    FName:=ExtractFileName(ScanItem.SrcName);

  case H of
    0: S:= '"'+FName+'"  ['+NameMSG[ErrMSG(N)]+' '+IntToStr(N)+'] ( - '
                     +IntToStr(TokenRow)+'  - '
                     +IntToStr(TokenCol)+'): '+S+'!';
    3: S:= '"'+FName+'"  ['+IntToStr(N)+'] ( - '
                     +IntToStr(TokenRow)+'  - '
                     +IntToStr(TokenCol)+'): '+S+';';
  end;
  WriteLn(CharToOem(S));
end;

end.
